
# save_result <- "/esarchive/scratch/drodrig1/experiments/Vitalise/evaluation/a5mm/"
test <- readRDS(paste0("/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/pm2p5cmaq/daily_mean/daily_mean_urban_pm2p5cmaq_20190101.rds"))

grid_total <- readRDS("/esarchive/scratch/drodrig1/experiments/Vitalise/plotting/data/receptor_grid.rds")
example_uk_grid      <- grid_total
output_grid <- readRDS("/esarchive/scratch/drodrig1/experiments/universalkriging/general/plot_archives/output_grid.rds")

index_vector <- 1:nrow(grid_total)
n_receptors = nrow(example_uk_grid)
dim(index_vector) <- c(receptors=n_receptors)
n_cores <- 8
pollutant_model <- "PM25"

# UK_mean ----------------------------------------------------------------------------------------------------------
# receptor_mean <- function(raw_data) {
#   daily_mean <- raw_data %>%
#     group_by(rec_id) %>%
#     mutate(!!paste0(pollutant_model,"_mean") := mean(!!as.name(pollutant_model), na.rm = T)) %>%
#     dplyr::select(-as.name(pollutant_model), -date)
#   daily_mean <- distinct(daily_mean)
#   daily_mean <- daily_mean[,c(4,1,2,3)]
#   names(daily_mean)[which(names(daily_mean) == paste0(pollutant_model,"_mean"), arr.ind = TRUE) ] = "model_value"
#   daily_mean <- daily_mean[order(daily_mean$rec_id),]
#   return(daily_mean)
# }


merge_uk_mean <- function(d_initial, d_final){
  res_totales <- readRDS(paste0("/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/pm2p5cmaq/daily_mean/daily_mean_urban_pm2p5cmaq_", dates[d_initial], ".rds"))
  res_totales <- arrange(res_totales, rec_id)
  res_totales <- res_totales$pm2p5cmaq_mean
  for(index in (d_initial+1):d_final){
    res_tot <- arrange(readRDS(paste0("/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/pm2p5cmaq/daily_mean/daily_mean_urban_pm2p5cmaq_", 
                                          dates[index], ".rds")),rec_id)$pm2p5cmaq_mean
    res_totales <- cbind(res_totales, res_tot)}
  res_total <- as.data.frame(apply(res_totales, MARGIN = 1, mean, na.rm = TRUE))
  names(res_total) <- "pollutant_uk"
  res_total <- cbind(res_total, example_uk_grid)
  saveRDS(res_total, paste0("/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/pm2p5cmaq/daily_mean/daily_mean_pm2p5cmaq_annual.rds"))
  }

for(d in dates){
  file_raw <- paste0("/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/UK/UK_gene_pm2p5cmaq_", d, ".rds")
  if(file.exists(file_raw) & !file.exists(paste0(save_result, "out/pm2p5cmaq/rds/mean/caliope_urban_results_mean", d, "_pm2p5cmaq.rds"))){
    print(paste0("Computing mean of day ", d))
    raw_model_1 <- readRDS(file_raw)
    res <- multiApply::Apply(list(index_vector), margins = 'receptors',
                             fun = receptor_mean,
                             raw_data = raw_model_1,
                             ncores = n_cores)$output1
    res <- as.data.frame(res)
    names(res) <- "model_value"
    res <- cbind(res, example_caliope_hour)
    saveRDS(res, paste0(caliope_path, "caliope_mean/caliope_mean_", d, ".rds")) #orden correcly by 1:length(rec_id)
  }else{print(paste0("No caliope-urban results for day ", d, " or mean already computed"))}
}

merge_uk_mean(1, length(dates))

#regrid -----------------------------------------------------------------------------------------------------------
regrid_ok <- function(non_uniform_data, target_grid,crs_sim = "+proj=utm +zone=31 +ellps=intl +units=m +no_defs"){
  if(isTRUE(class(non_uniform_data) != "SpatialPointsDataFrame")){
    non_uniform_data <- sp::SpatialPointsDataFrame(non_uniform_data[,c("X", "Y")],non_uniform_data)
    sp::proj4string(non_uniform_data) <- crs_sim
  }
  vf_ok      <- autofitVariogram(pollutant_uk ~ 1, non_uniform_data)
  ok_regular <- gstat(formula = pollutant_uk ~ 1, data = non_uniform_data, model = vf_ok$var_model, nmax = 20)
  regular <- predict(ok_regular, target_grid)
  regular <- sp::spTransform(regular, sp::CRS("+proj=longlat"))
  pixels <- sp::SpatialPixelsDataFrame(regular,tolerance = 0.99, as.data.frame(regular[,"var1.pred"]))
  mean_raster <- raster::raster(pixels[,'var1.pred'])
  return(mean_raster)}

receptor   <- readRDS(paste0(general, "plot_archives/output_grid.rds")) #uniform gridhoy

UK_mean               <- readRDS("/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/pm2p5cmaq/daily_mean/daily_mean_pm2p5cmaq_annual.rds")
UK_mean <- st_as_sf(UK_mean, crs = crs_utm)
UK_mean <- cbind(UK_mean, st_coordinates(UK_mean))
UK_mean <- st_drop_geometry(UK_mean)
UK_mean_uniform_ok    <- regrid_ok(non_uniform_data = UK_mean, target_grid = output_grid)
saveRDS(UK_mean_uniform_ok, "/esarchive/scratch/drodrig1/experiments/Vitalise/OK_scenarios/a5mm/pm2p5cmaq/daily_mean/daily_mean_annual_pm2p5cmaq_regridok.rds")

